import hashlib
import argparse

_128_BITS = "0xFFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF_FFFF"

def parse_int(n: str) -> int:
    if n.startswith("0b") or n.startswith("0B"):
        return int(n[2:], 2)
    elif n.startswith("0o") or n.startswith("0O"):
        return int(n[2:], 8)
    elif n.startswith("0x") or n.startswith("0X"):
        return int(n[2:], 16)
    return int(n)

def custom_hash(message: str, mask: int) -> str:
    hash = hashlib.md5(message.encode())

    return int.from_bytes(hash.digest(), "big") & mask

if __name__ == "__main__":
    parser = argparse.ArgumentParser("hash", description="returns the hash value of the given message")
    parser.add_argument("message")
    parser.add_argument("-m", "--mask", default=_128_BITS, help="the bit mask")

    args = parser.parse_args()

    print(custom_hash(args.message, parse_int(args.mask)))